import processing.serial.*;
import controlP5.*;
import java.util.*;

Serial myPort = null;

ControlP5 cp5;

ButtonBar b, c;
Button connect, disconnect;

boolean com_select, baud_select = false;
String[] ports;
String[] bauds = {"300", "1200", "2400", "4800", "9600", "19200", "38400", "57600", "74880" , "115200", "230440", "250000"};
int portnum, baudnum;
float inByte = 0;
int xPos = 1;

void setup(){
  size(1024,768);
  background(200);
  ports = Serial.list();
  cp5 = new ControlP5(this);
  b = cp5.addButtonBar("bar").setPosition(0, 0).setSize(1024, 20).addItems(ports);
  c = cp5.addButtonBar("barka").setPosition(0, 20).setSize(1024, 20).addItems(bauds);
  connect = cp5.addButton("Connect").setPosition(904,40).setSize(60,20).setValue(0).activateBy(ControlP5.RELEASE);
  disconnect = cp5.addButton("Disconnect").setPosition(964,40).setSize(60,20).setValue(0).activateBy(ControlP5.RELEASE);
  
  b.onMove(new CallbackListener(){
    public void controlEvent(CallbackEvent ev) {
      ButtonBar bar = (ButtonBar)ev.getController();
    }
  });
  
  c.onMove(new CallbackListener(){
    public void controlEvent(CallbackEvent ev) {
     ButtonBar barka = (ButtonBar)ev.getController();
    }
  });
}

void bar(int n) {
  println("Com port :", ports[n]);
  portnum = n;
  com_select = true;
}

void barka(int n) {
  println("Baud rate :", bauds[n]);
  baudnum = n;
  baud_select = true;
}

void Connect(int value){
  if(com_select == true && baud_select == true && myPort == null){
    myPort = new Serial(this, ports[portnum], int(bauds[baudnum]));
    myPort.bufferUntil('\n');
    println(ports[portnum], " connected.");
  }
}

void Disconnect(int value){
  if (myPort != null){
    myPort.stop();
    myPort = null;
    println(ports[portnum], " disconnected.");
  }
  ports = Serial.list();
  b.clear();
  b.addItems(ports);
  b.update();
}

void draw() { 
  if (ports == null){
    println("ads");
  }
  frameRate(120);
  stroke(255, 0, 0);
  line(xPos, height/2 + inByte, xPos, height/2 - inByte);
  if (xPos >= width) {
    xPos = 0;
    background(200);
  } else {
    xPos++;
  }
}

void serialEvent (Serial myPort) {
  String inString = myPort.readStringUntil('\n');
  if (inString != null) {
    inString = trim(inString);
    inByte = float(inString);
    //println(inByte);
    inByte = map(inByte, 0, 1023, 0, height);
  }
}